# coding: utf-8

"""
    Jaqpot API

    A modern RESTful API for model management and prediction services, built using Spring Boot and Kotlin. Supports seamless integration with machine learning workflows.

    The version of the OpenAPI document: 1.0.0
    Contact: upci.ntua@gmail.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from jaqpot_api_client.models.get_users200_response_pageable import GetUsers200ResponsePageable
from jaqpot_api_client.models.get_users200_response_pageable_sort import GetUsers200ResponsePageableSort
from jaqpot_api_client.models.user import User
from typing import Optional, Set
from typing_extensions import Self

class GetUsers200Response(BaseModel):
    """
    GetUsers200Response
    """ # noqa: E501
    content: Optional[List[User]] = None
    pageable: Optional[GetUsers200ResponsePageable] = None
    last: Optional[StrictBool] = None
    total_pages: Optional[StrictInt] = Field(default=None, alias="totalPages")
    total_elements: Optional[StrictInt] = Field(default=None, alias="totalElements")
    size: Optional[StrictInt] = None
    number: Optional[StrictInt] = None
    sort: Optional[GetUsers200ResponsePageableSort] = None
    first: Optional[StrictBool] = None
    number_of_elements: Optional[StrictInt] = Field(default=None, alias="numberOfElements")
    empty: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["content", "pageable", "last", "totalPages", "totalElements", "size", "number", "sort", "first", "numberOfElements", "empty"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetUsers200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in content (list)
        _items = []
        if self.content:
            for _item_content in self.content:
                if _item_content:
                    _items.append(_item_content.to_dict())
            _dict['content'] = _items
        # override the default output from pydantic by calling `to_dict()` of pageable
        if self.pageable:
            _dict['pageable'] = self.pageable.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sort
        if self.sort:
            _dict['sort'] = self.sort.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetUsers200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "content": [User.from_dict(_item) for _item in obj["content"]] if obj.get("content") is not None else None,
            "pageable": GetUsers200ResponsePageable.from_dict(obj["pageable"]) if obj.get("pageable") is not None else None,
            "last": obj.get("last"),
            "totalPages": obj.get("totalPages"),
            "totalElements": obj.get("totalElements"),
            "size": obj.get("size"),
            "number": obj.get("number"),
            "sort": GetUsers200ResponsePageableSort.from_dict(obj["sort"]) if obj.get("sort") is not None else None,
            "first": obj.get("first"),
            "numberOfElements": obj.get("numberOfElements"),
            "empty": obj.get("empty")
        })
        return _obj


